class Tag < ActiveRecord::Base

  has_and_belongs_to_many :benchmark_batches

  def all_configurations
    benchmark_batches.map(&:benchmark_configuration).uniq
  end

  def all_benchmark_infos
    benchmark_batches.
      flat_map(&:benchmark_results).
      map(&:benchmark_info).
      uniq.
      sort { |a, b| a.name <=> b.name }
  end

  def latest_results_for(benchmark_info, benchmark_configuration)
    benchmark_batches.
      joins(:benchmark_results).
      where(benchmark_configuration: benchmark_configuration,
            benchmark_results: { benchmark_info: benchmark_info }).
      max { |a, b| a.performed_at <=> b.performed_at }.
      result_for(benchmark_info)
  end

end
